#include <QQmlContext>
#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include "utils.h"
#include <QFile>
#include <QTextStream>
#include <QDebug>
#ifdef Q_OS_ANDROID
#include <QAndroidJniObject>
#include <QtAndroid>
#endif

int main(int argc, char *argv[])
{

    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    QGuiApplication app(argc, argv);

    Utils ut;

    ut.engine.rootContext()->setContextProperty("qtc", &ut);
    ut.setPath("none");
#ifdef Q_OS_WIN
    if(argc==1){

        ut.engine.load(QUrl(QStringLiteral("qrc:/main.qml")));
    } else if(argc==2){
        if(QFile::exists(argv[1]))
        {
            QFile file(argv[1]);
            ut.setPath("file:///"+QString(argv[1]));
            if(file.open(QIODevice::ReadOnly))
            {
                QTextStream stream(&file);
                QString str = stream.readAll();
                bool isWindow = str.contains(QRegExp("(Window\\s*\\{)"));

                if(isWindow){

                    ut.engine.load(argv[1]);

                } else {

                    ut.engine.load(QUrl(QStringLiteral("qrc:/main.qml")));
                }
            }
        }
    }
#endif

//ut.engine.load(QUrl(QStringLiteral("qrc:/main.qml")));
#ifdef Q_OS_ANDROID


    QAndroidJniObject activity = QtAndroid::androidActivity();
    if (activity.isValid()) {
        QAndroidJniObject intent = activity.callObjectMethod("getIntent", "()Landroid/content/Intent;");
        if (intent.isValid()) {
            QAndroidJniObject data = intent.callObjectMethod("getData", "()Landroid/net/Uri;");
            if (data.isValid()) {
                QAndroidJniObject path = data.callObjectMethod("getPath", "()Ljava/lang/String;");
                if (path.isValid()){
                    ut.setPath("file://"+path.toString());
                }
            }
        }
    }
#endif

    if (ut.engine.rootObjects().isEmpty()){
        ut.engine.load(QUrl(QStringLiteral("qrc:/main.qml")));
    }
    if (ut.engine.rootObjects().isEmpty())
        return -1;

    return app.exec();
}
